<template>
  <!-- 新增编辑 -->
  <a-modal
    :width="600"
    :maskClosable="false"
    :visible="props.visible"
    :confirm-loading="loading"
    :forceRender="true"
    style="top: 40px"
    :title="isUpdate ? '编辑流程业务关联' : '新建流程业务关联'"
    :body-style="{ paddingBottom: '8px' }"
    @update:visible="updateVisible"
    @ok="save"
    @close="updateVisible(false)"
  >
    <AssociationForm v-model:form="form" ref="modelFormRef"></AssociationForm>
  </a-modal>
</template>

<script setup name="AssociationAddEdit">
import { ref, onMounted } from 'vue';
import AssociationForm from './association-form.vue';
import { message } from 'ant-design-vue';
import { AssociationApi } from '../api/AssociationApi';
import { getBusinessMaxSort } from '@/utils/common/util';

const props = defineProps({
  visible: Boolean,
  data: Object
});

const emits = defineEmits(['update:visible', 'done']);
// 弹框加载
const loading = ref(false);
// 是否是编辑状态
const isUpdate = ref(false);
// 表单数据
const form = ref({});
// ref
const modelFormRef = ref(null);

onMounted(async() => {
  if (props.data) {
    isUpdate.value = true;
    getDetail();
  } else {
    isUpdate.value = false;
    form.value.fldSort = await getBusinessMaxSort('FLOW_BUSINESS_LINK');
  }
});

// 获取详情
const getDetail = () => {
  AssociationApi.detail({ flowBusinessId: props.data.flowBusinessId }).then(res => {
    form.value = Object.assign({}, res);
    if (form.value.flowCategoryId) {
      modelFormRef.value.getModelList(form.value.flowCategoryId);
    }
  });
};

// 更改弹框状态
const updateVisible = value => {
  emits('update:visible', value);
};

// 点击保存
const save = async () => {
  modelFormRef.value.$refs.formRef.validate().then(async valid => {
    if (valid) {
      // 修改加载框为正在加载
      loading.value = true;

      let result = null;

      // 执行编辑或修改
      if (isUpdate.value) {
        result = AssociationApi.edit(form.value);
      } else {
        result = AssociationApi.add(form.value);
      }
      result
        .then(async result => {
          // 移除加载框
          loading.value = false;

          // 提示添加成功
          message.success(result.message);
          // 关闭弹框，通过控制visible的值，传递给父组件
          updateVisible(false);

          // 触发父组件done事件
          emits('done');
        })
        .catch(() => {
          loading.value = false;
        });
    }
  });
};
</script>

<style></style>
